<template>
  <div>
    <md-card
      v-if="user"
      class="profile-card md-layout-item md-size-30 md-small-size-100"
    >
      <md-list class="md-double-line md-dense">
        <div class="profile-header">
          <div class="md-title">{{ user.name }}</div>
          <md-content
            class="avatar-container md-elevation-6 md-theme-demo-light"
          >
            <div class="overlay-container" v-if="showOverlay || !form.avatar">
              <md-progress-spinner
                :md-diameter="30"
                :md-stroke="3"
                md-mode="indeterminate"
              ></md-progress-spinner>
              <div class="overlay"></div>
            </div>
            <img v-else :src="form.avatar" alt="avatar" />
            <div
              @click.prevent="$refs.fileInput.click()"
              class="overlay-action-icon"
            >
              <md-icon class="md-primary">edit</md-icon>
            </div>
            <!-- input for avatar uploading -->
            <input
              ref="fileInput"
              class="file-input"
              type="file"
              name="file"
              @change="convertImageToString"
            />
          </md-content>
        </div>

        <md-divider></md-divider>

        <md-subheader>Username</md-subheader>
        <md-list-item>
          <md-icon class="md-primary">account_circle</md-icon>
          <div class="md-list-item-text">
            <span>{{ user.username }}</span>
          </div>
        </md-list-item>

        <md-divider></md-divider>

        <md-subheader>Email</md-subheader>

        <md-list-item>
          <md-icon class="md-primary">email</md-icon>

          <div class="md-list-item-text">
            <span>{{ user.email }}</span>
          </div>
        </md-list-item>
        <md-card-actions v-if="toggleActions" md-alignment="right">
          <md-button @click.prevent="updateUserProfile">Save changes</md-button>
        </md-card-actions>
      </md-list>
    </md-card>
  </div>
</template>

<script>
import { mapActions, mapGetters } from "vuex";
import { convertToBase64 } from "@/mixins/mixins";

export default {
  mixins: [convertToBase64],
  data: () => ({
    file: "",
    form: {
      avatar: "",
      username: null
    },
    showOverlay: false,
    toggleActions: false
  }),
  computed: {
    ...mapGetters(["user"])
  },
  methods: {
    ...mapActions(["getProfile", "updateProfile"]),

    async convertImageToString(event) {
      this.toggleActions = true;
      this.file = event.target.files[0];
      try {
        const base64String = await this.convertToBase64(event);
        this.form.avatar = base64String;
      } catch (error) {
        console.log("Error: ", error);
      }
    },

    updateUserProfile() {
      this.showOverlay = !this.showOverlay;
      this.updateProfile({
        avatar: this.form.avatar,
        id: this.user.userId
      }).then(() => {
        this.getProfile().then(
          () => (
            (this.showOverlay = !this.showOverlay), (this.toggleActions = false)
          )
        );
      });
    }
  },
  async created() {
    await this.getProfile();
    this.form.avatar = this.user.avatar;
    this.form.username = this.user.username;
  }
};
</script>

<style lang="scss">
.profile-card {
  margin-left: auto;
  margin-right: auto;
  .md-dense {
    padding-top: 0;
  }
}
.profile-header {
  background: rgb(99, 46, 213);
  background: linear-gradient(
    124deg,
    rgba(99, 46, 213, 1) 0%,
    rgba(179, 72, 164, 1) 49%,
    rgba(253, 29, 60, 1) 100%
  );
  padding: 35px 10px 40px 10px;
  .md-title {
    color: #ffffff;
    margin-bottom: 20px;
    min-height: 32px;
  }
  .avatar-container {
    height: 90px;
    width: 90px;
    border-radius: 50%;
    overflow: hidden;
    display: flex;
    justify-content: center;
    align-items: center;
    margin-left: auto;
    margin-right: auto;
    position: relative;
    .file-input {
      display: none;
      opacity: 0;
    }
    .overlay-action-icon {
      opacity: 0;
      background-color: rgba(255, 255, 255, 0.6);
      height: 100%;
      width: 100%;
      position: absolute;
      display: flex;
      justify-content: center;
      align-items: center;
      transition: opacity 0.2s;
      cursor: pointer;
    }
    &:hover {
      .overlay-action-icon {
        opacity: 1;
        transition: opacity 0.2s;
      }
    }
    .overlay-container {
      display: flex;
      justify-content: center;
      align-items: center;
      position: absolute;
      background-color: rgba(255, 255, 255, 0.6);
      height: 100%;
      width: 100%;
    }
    .avatar-image {
      height: auto;
    }
  }
}
</style>
